/*
 * Copyright 2005-2006 Myriad Genetics, Inc.
 *
 * All rights reserved.
 */

package com.myriad.tmap.compute;

/** Represents a map, i.e. a list of markers with their positions. */
public class Map {
    public Map(MarkerPosition[] aMarkers)
    {
        markers = aMarkers;
    }
    
    /** Returns a new Map containing the same markers in reverse order.
     */
    public Map reverse()
    {
        MarkerPosition[]    newMarkers = new MarkerPosition[markers.length];
        double              sizeMoth = markers[markers.length - 1].posMoth;
        double              sizeFath = markers[markers.length - 1].posFath;
        
        for (int i = 0; i < markers.length; ++i) {
            MarkerPosition      newPos;
            
            newPos = new MarkerPosition(markers[i].name,
                                        sizeMoth - markers[i].posMoth,
                                        sizeFath - markers[i].posFath,
                                        markers[i].errorMoth,
                                        markers[i].errorFath);
            newMarkers[markers.length - 1 - i] = newPos;
        }
        
        return new Map(newMarkers);
    }
    
    /** The markers and the associated parameters which make up the map.
     */
    public MarkerPosition[] markers;
}
